#!/usr/local/bin/perl
# Show a list of cluster servers that can be shut down

require './cluster-shutdown-lib.pl';
&ui_print_header(undef, $text{'index_title'}, "", undef, 0, 1);

@servers = grep { $_->{'user'} } &servers::list_servers();

# Check which ones are up, in parallel
foreach $s (@servers) {
	if (!($pid = fork())) {
		$out = `ping -c 1 -w 1 $s->{'host'} 2>&1`;
		exit($?/256);
		}
	$pid{$s} = $pid;
	}
foreach $s (@servers) {
	$pid = waitpid($pid{$s}, 0);
	$up{$s} = !$?;
	}

if (@servers) {
	print &ui_form_start("shutdown.cgi", "post");
	print &ui_columns_start([ "",
				  $text{'index_host'},
				  $text{'index_desc'},
				  $text{'index_os'},
				  $text{'index_up'} ]);
	foreach $s (@servers) {
		($st) = grep { $_->[0] eq $s->{'type'} } @servers::server_types;
		print &ui_columns_row(
			[ &ui_checkbox("id", $s->{'id'}),
			  $s->{'host'},
			  $s->{'desc'},
			  $st->[1],
			  $up{$s} ? "<font color=#00aa00>$text{'yes'}</font>"
				  : "<font color=#ff0000>$text{'no'}</font>" ]);
		}
	print &ui_columns_end();
	print &ui_form_end([ [ "shut", $text{'index_shut'} ],
			     [ "reboot", $text{'index_reboot'} ] ]);
	}
else {
	print "<b>",&text('index_none', "../servers/"),"</b><p>\n";
	}

&ui_print_footer("/", $text{'index'});

